#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

int n, k, type;
vector<vector<int>> g;
vector<int> dist;
vector<int> dp;
vector<int> p;

void dfs(int v) {
    for (auto u: g[v]) {
        if (dist[u] == 1e9) {
            dist[u] = dist[v] + 1;
            dp[u] = dist[v] + 1;
            p[u] = v;
            dfs(u);
        }
    }
    for (auto u: g[v]) {
        if (u != p[v]) {
            dp[v] = max(dp[v], dp[u]);
        }
    }
}

vector<int> up;

void ups(int v) {
    int m1 = -1, m2 = -1;
    for (auto u: g[v]) {
        if (u != p[v]) {
            if (m1 == -1 || dp[m1] < dp[u]) {
                m2 = m1;
                m1 = u;
            } else if (m2 == -1 || dp[m2] < dp[u]) {
                m2 = u;
            }
        }
    }
    for (auto u: g[v]) {
        if (u != p[v] && up[u] == -1) {
            up[u] = max(up[v], dist[v]);
            if (m2 != -1) {
                up[u] = max(up[u], dp[(m1 == u ? m2 : m1)]);
            }
            ups(u);
        }
    }
}

void solve() {
    dist.resize(n, 1e9);
    dp.resize(n, -1);
    up.resize(n, -1);
    p.resize(n, -1);
    dist[0] = 0;
    dfs(0);
    ups(0);
    int otv = 1e9;
    for (int i = 0; i < n; i++) {
        otv = min(otv, max(dp[i] - dist[i] + 1, up[i]));
    }
    cout << otv;
    exit(0);
}


int get(int v, int pr) {
    int ret = 0;
    for (auto u: g[v]) {
        if (u != pr) {
            if (dist[u] > dist[v] + 1) {
                dist[u] = dist[v] + 1;
                ret = max(ret, get(u, v));
            } else if (dist[u] == 1) {
                ret = max(ret, get(u, v));
            }
        }
    }
    return max(ret, dist[v]);
}

void solve_stupid() {
    dist.resize(n, 1e9);
    if (type == 0) {
        int otv = 1e9;
        for (int mask = 0; mask < (1 << n); mask++) {
            dist.assign(n, 1e9);
            dist[0] = 0;
            int c = 0;
            for (int i = 1; i < n; i++) {
                if (mask & (1 << i)) {
                    c++;
                    dist[i] = 1;
                }
            }
            if (c > k) {
                continue;
            }
            otv = min(otv, get(0, -1));
        }
        cout << otv << '\n';
    } else {
        for (int i = 0; i < n; i++) {
            int otv = 1e8;
            for (int mask = 0; mask < (1 << n); mask++) {
                dist.assign(n, 1e9);
                dist[i] = 0;
                int c = 0;
                for (int j = 0; j < n; j++) {
                    if (i == j) continue;
                    if (mask & (1 << j)) {
                        c++;
                        dist[j] = 1;
                    }
                }
                if (c > k) {
                    continue;
                }
                otv = min(otv, get(i, -1));
            }
            cout << otv << ' ';
        }
    }
    exit(0);
}

signed main() {
    cin >> n >> k >> type;
    g.resize(n);
    bool ok = true;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        if (a - b != -1) {
            ok = false;
        }
        g[a].push_back(b);
        g[b].push_back(a);
    }
    if (ok) {
        if (type == 0) {
            int otv = 1e8;
            for (int j = 0; j <= k; j++) {
                otv = min(otv, max((n - 1 + j) / (j + 1), (k - j) / (k - j + 1)));
            }
            cout << otv << ' ';
        } else {
            for (int i = 0; i < n; i++) {
                int otv = 1e8;
                for (int j = 0; j <= k; j++) {
                    otv = min(otv, max((n - 1 - i + j) / (j + 1), (i + k - j) / (k - j + 1)));
                }
                cout << otv << ' ';
            }
        }
        return 0;
    }
    if (n <= 50) {
        solve_stupid();
    }
    if (k == 1 && type == 0) {
        solve();
    }
}
