#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/trie_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

struct quest {
    int x, l = -1, r = -1;
};

vector<pair<int, int>> g;
vector<vector<int>> d;
vector<int> t, p;
vector<int> got;

vector<int> operator+(vector<int> a, vector<int> b) {
    int l = 0, r = 0;
    vector<int> otv;
    while (l < a.size() && r < b.size()) {
        if (a[l] < b[r]) {
            otv.push_back(a[l]);
            l++;
        } else {
            otv.push_back(b[r]);
            r++;
        }
    }
    while (l < a.size()) {
        otv.push_back(a[l]);
        l++;
    }
    while (r < b.size()) {
        otv.push_back(b[r]);
        r++;
    }
    return otv;
}

void build(int v) {
    if (v == -1) return;
    if (g[v].first == g[v].second && g[v].first == -1) {
        d[v] = {v};
        return;
    }
    build(g[v].first);
    build(g[v].second);
    d[v] = {v};
    if (g[v].first != -1) {
        d[v] = d[g[v].first] + d[v];
    }
    if (g[v].second != -1) {
        d[v] = d[g[v].second] + d[v];
    }
}

void push(int v) {
    if (p[v] != 10) {
        t[v * 2 + 1] = p[v];
        t[v * 2 + 2] = p[v];
        p[v * 2 + 1] = p[v];
        p[v * 2 + 2] = p[v];
    }
    p[v] = 10;
}

void setx(int v, int tl, int tr, int l, int r, int x) {
    if (l <= tl && tr <= r) {
        t[v] = x;
        p[v] = x;
        return;
    }
    if (tr <= l || r <= tl) {
        return;
    }
    push(v);
    int m = (tl + tr) / 2;
    setx(v * 2 + 1, tl, m, l, r, x);
    setx(v * 2 + 2, m, tr, l, r, x);
}

int getx(int v, int l, int r, int pos) {
    if (r - l == 1) {
        return t[v];
    }
    push(v);
    int m = (r + l) / 2;
    if (pos < m) {
        return getx(v * 2 + 1, l, m, pos);
    } else {
        return getx(v * 2 + 2, m, r, pos);
    }
}

int n;

int getp(int v, int x) {
    if (v == x) {
        int s = getx(0, 0, n, v);
        return 1 + (s > -1) * d[g[v].first].size() + (s > 0) * d[g[v].second].size();
    }
    auto smd = lower_bound(d[g[v].first].begin(), d[g[v].first].end(), x);
    if (smd == d[g[v].first].end()) {
        return (int) d[g[v].first].size() + getp(g[v].second, x) + (getx(0, 0, n, v) != 1);
    }
    if (*smd == x) {
        return getp(g[v].first, x) + (getx(0, 0, n, v) == -1);
    } else {
        return (int) d[g[v].first].size() + getp(g[v].second, x) + (getx(0, 0, n, v) != 1);
    }
}

int gotp(int v, int x) {
    if (v == x) {
        int s = got[v];
        return 1 + (s > -1) * d[g[v].first].size() + (s > 0) * d[g[v].second].size();
    }
    auto smd = lower_bound(d[g[v].first].begin(), d[g[v].first].end(), x);
    if (smd == d[g[v].first].end()) {
        return (int) d[g[v].first].size() + gotp(g[v].second, x) + (got[v] != 1);
    }
    if (*smd == x) {
        return gotp(g[v].first, x) + (got[v] == -1);
    } else {
        return (int) d[g[v].first].size() + gotp(g[v].second, x) + (got[v] != 1);
    }
}

void fma(int v, int l, int r) {
    if (r - l == 1) {
        got[l] = t[v];
        return;
    }
    push(v);
    int m = (r + l) / 2;
    fma(v * 2 + 1, l, m);
    fma(v * 2 + 2, m, r);
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q;
    cin >> n >> q;
    int tn = 1;
    while (tn <= n) { tn *= 2; }
    g.resize(tn);
    d.resize(tn);
    t.resize(4 * tn, -1);
    p.resize(4 * tn, 10);
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;
        g[i] = {--l, --r};
    }
    vector<quest> ask;
    bool was = false;
    bool before = true;
    bool lr = true;
    while (q--) {
        int type;
        cin >> type;
        if (type == 2) {
            int x;
            cin >> x;
//            cout << getp(0, --x) << '\n';
            ask.push_back({x, -1, -1});
            was = true;
        } else {
            int l, r, x;
            cin >> l >> r >> x;
//            --l;
//            setx(0, 0, n, l, r, x);
            ask.push_back({x, l, r});
            if (was) {
                before = false;
            }
            if (l != r) {
                lr = false;
            }
        }
    }
    build(0);
    if (lr) {
        got.resize(n, -1);
        for (auto &i: ask) {
            if (i.l == -1) {
                int x = i.x;
                cout << gotp(0, --x) << '\n';
            } else {
                int l = i.l, r = i.r, x = i.x;
                --l;
                got[l] = x;
            }
        }
        exit(0);
    }
    if (before) {
        int j = 0;
        for (; j < ask.size(); j++) {
            if (ask[j].l == -1) {
                break;
            } else {
                setx(0, 0, n, ask[j].l - 1, ask[j].r, ask[j].x);
            }
        }
        got.resize(n, -1);
        fma(0, 0, n);
        for (; j < ask.size(); j++) {
            cout << gotp(0, ask[j].x - 1) << '\n';
        }
        exit(0);
    }
    for (auto &i: ask) {
        if (i.l == -1) {
            int x = i.x;
            cout << getp(0, --x) << '\n';
        } else {
            int l = i.l, r = i.r, x = i.x;
            --l;
            setx(0, 0, n, l, r, x);
        }
    }
}